from PIL import Image, ImageEnhance
import pytesseract
import json
import datetime

from text_model import Page, Word
from pdf_to_image import get_pdf_as_image

def _read_text_via_ocr(p_image, p_lang="deu"):
    return pytesseract.image_to_data(p_image, lang=p_lang).split("\n")[1:]

def _generate_wordlist_from_rawtext(p_raw):
    word_list = []
    for raw_word in p_raw:
        raw_word = raw_word.split("\t")
        word = Word(raw_word)
        word_list.append(word)
    return word_list

def _generate_textmodel_from_wordlist(p_wordlist):
    page = Page()
    for word in p_wordlist:
        page.insert_word(word)
    return page

def _binarize_image(p_image):
    width, height = p_image.size
    binarized = Image.new("RGB", p_image.size)
    binarized_data = []
    pixeldata = p_image.getdata()
    for pixel in pixeldata:

def _preprocess_image(p_image):
    p_image = p_image.convert("L")
    #contrast = ImageEnhance.Contrast(p_image)
    #return contrast.enhance(8)

def generate_text_from_image(p_image, p_lang="deu"):
    image = _preprocess_image(p_image)
    image.save(str(int(datetime.datetime.now().timestamp())) + ".png")
    raw_data = _read_text_via_ocr(image, p_lang)
    wordlist = _generate_wordlist_from_rawtext(raw_data)
    return _generate_textmodel_from_wordlist(wordlist)

def _page_to_list(p_page):
    block_as_string = []
    for block in p_page.get_block_list():
        line_as_string = []
        for line in block.get_line_list():
            line_as_string.append(str(line))
        block_as_string.append(line_as_string)
    return block_as_string

def save_page_list_to_file(p_page_list, p_name):
    page_list = []
    for page in p_page_list:
        block_list = _page_to_list(page)
        page_list.append(block_list)
    file = open(p_name + ".ptt", "w")
    json.dump(page_list, file)
    file.close()

def pdf_to_text(p_path_to_pdf):
    images = get_pdf_as_image(p_path_to_pdf)
    pdf_name = p_path_to_pdf.split("/")[-1]
    file = open(pdf_name + ".ms", "w")
    for image in images:
        text = generate_text_from_image(image)
        file.write(str(text))
        file.write("\n##################\n")
    file.close()
    
    